/*
    This program tests your implementation of the Pair class.

    Do not make any changes to this file. This program should compile
    without any errors. If this program will not compile, then you need
    to fix something in your Pair class.

    When you run this program, check that the output agrees with the
    contents of the file SampleOutput.txt. If the output does not agree
    with SampleOutput.txt, then you need to fix something in your Pair class.
*/

public class TestPairs
{
    public static void main(String[] args)
    {
        Pair<Integer, Integer> p1 = new Pair<Integer, Integer>(4, 5);
        Pair<Integer, Integer> p2 = new Pair<Integer, Integer>(1, 2);
        Pair<Integer, Integer> p3 = new Pair<Integer, Integer>(6, 7);
        Pair<Integer, Integer> p4 = new Pair<Integer, Integer>(4, 6);
        Pair<Integer, Integer> p5 = new Pair<Integer, Integer>(5, 5);

        System.out.println( "p1 = " + p1 );
        System.out.println( "p2 = " + p2 );
        System.out.println( "p3 = " + p3 );
        System.out.println( "p4 = " + p4 );
        System.out.println( "p5 = " + p5 );

        System.out.println("The result from p1.compareTo(p2) = " + p1.compareTo(p2) );
        System.out.println("The result from p1.compareTo(p3) = " + p1.compareTo(p3) );
        System.out.println("The result from p1.compareTo(p4) = " + p1.compareTo(p4) );
        System.out.println("The result from p1.compareTo(p5) = " + p1.compareTo(p5) );

        Pair<String, Integer> p6 = new Pair<String, Integer>("pear", 5);
        Pair<String, Integer> p7 = new Pair<String, Integer>("apple", 2);
        Pair<String, Integer> p8 = new Pair<String, Integer>("orange", 10);

        System.out.println( "p6 = " + p6 );
        System.out.println( "p7 = " + p7 );
        System.out.println( "p8 = " + p8 );

        System.out.println("The result from p6.compareTo(p7) = " + p6.compareTo(p7) );
        System.out.println("The result from p6.maxPair(p8) = " + p6.maxPair(p8) );

        Pair<Integer, String> p9 = new Pair<Integer, String>();
        p9.setFirst(p8.getSecond());
        p9.setSecond(p8.getFirst());
        System.out.println( "p9 = " + p9 );
        System.out.println("The result from p9 == p8.transpose() = " + (p9 == p8.transpose()) );
        System.out.println("The result from p9.equals(p8.transpose()) = " + p9.equals(p8.transpose()) );

        System.out.println("The result from p8.replaceSecond(\"grape\") = " + p8.replaceSecond("grape") );
        System.out.println("The result from p8.replaceFirst(3.14) = " + p8.replaceFirst(3.14) );
        System.out.println("The result from p8.<Integer>replaceFirst(3) = " + p8.<Integer>replaceFirst(3) );

        Pair<Integer, Double> p10 = new Pair<Integer, Double>(10, 12.3);
        Pair<Integer, Double> p11 = new Pair<Integer, Double>(20, 0.045);

        System.out.println( "p10 = " + p10 );
        System.out.println( "p11 = " + p11 );
        System.out.println("The result from Pair.addPairOfNumbers(p10,p11) = "
                               + Pair.addPairOfNumbers(p10,p11));


        // The following lines should each produce compiler errors (when uncommented).
        // p6.compareTo(p5);
        // p6.maxPair(p5);
        // p6.<Double>replaceSecond("wrong");

    }//main

}//TestPairs
